<template lang="pug">
.home
	.home__wrapper
		.home__header
			.home__create.link.link--default(@click="onCreateCandidate") #[i.fas.fa-plus-square] Create candidate
			.home__search.icon.icon--left
				input.home__search-input(@input="onSearchCandidate" v-model="search" placeholder="Type a candidate's name..." autocomplete="off")
				i.fa.fa-search

		.home__candidates
			template(v-if="loading")
				loader.home__loader
			template(v-else)
				candidate.home__candidate(v-for="candidate in _getCandidates" :candidate="candidate" :key="candidate._id")

	create-candidate(ref="createCandidate")
</template>



<script>
import { mapActions, mapGetters } from 'vuex'
import { debounce } from 'debounce'

import Candidate from '@/components/Candidate'
import Loader from '@/components/Loader'
import CreateCandidate from '@/components/modals/CreateCandidate'

export default {
	components: {
		Candidate,
		Loader,
		CreateCandidate
	},

	data() {
		return {
			loading: false,
			search: ''
		}
	},

	computed: {
		...mapGetters('root', [
			'_getCandidates'
		])
	},

	methods: {
		...mapActions('root', [
			'$getCandidates'
		]),

		onCreateCandidate() {
			this.$refs.createCandidate.openModal()
		},

		onSearchCandidate: debounce(function() {
				let search = this.search

				this.loading = true

				this.$getCandidates({ params: { search } }).then(data => {
					this.loading = false
				})
		}, 500)
	}
}
</script>



<style lang="scss" scoped>
.home {
    $this: &;
    min-height: 100vh;
    background-color: #f5f5f9;
    padding: 100px 0;

    &__wrapper {
        max-width: 600px;
        margin: auto;
        background-color: white;
        padding: 50px;
        border-radius: 5px;
    }

    &__header {
        margin-bottom: 50px;
    }

    &__search {
        &-input {
            background: lighten($light_gray, 10%);
            border: none;
        }
    }

    &__create {
        margin-left: auto;
        margin-bottom: 25px;
        width: max-content;
    }

    &__candidates {
        height: 400px;
		overflow-y: auto;
    }

    &__loader {
        display: flex;
        justify-content: center;
        align-items: center;
        min-height: inherit;
        margin: auto;
    }
}
</style>
